# multirmd.r  (encoding: cp932, 2017/01/28)
    ## rmarkdownev[g̎擾̑
set.mrmd <- function(tfile) {
    tvect <- scan(tfile, what=character(), sep="\n", blank.lines.skip=F)
    m1 <- regexpr("^## +\\@knitr +", tvect)
    m2 <- c(regexpr("^#\\' *", tvect), -1)
    m3 <- c(regexpr("^#\\+ *", tvect), -1)
    chunk.name <- "none"
    cv <- c()
    tpl <- list()
    tindex <- c()
    topt <- list()
    for (i in 1:length(tvect)) {
        if (m1[i] != -1) {
           chunk.name <- sub("^## +\\@knitr +", "", tvect[i])
            cv <- c(cv, chunk.name)
            next
        }
        if (m3[i] != -1) {
            opt.str <- sub("^#\\+ *", "", tvect[i])
            if (opt.str != "")  topt[[chunk.name]] <- opt.str
            next
        }
        if (m2[i] != -1) {
            tindex <- c(tindex, i)
            if (m2[i+1] == -1) {
                w <- gsub("^#\\' ?", "", tvect[tindex])
                w <- c(w, "")
                tpl[[chunk.name]] <- c(tpl[[chunk.name]],
                    paste(w, collapse="\n"))
                tindex <- c()
            }
        }
    }
    cv.str = ""
    for (i in 1:length(cv)) {
        opt.str <- topt[[cv[i]]]
        if (is.null(opt.str))  opt.str <- "include=FALSE"
        cv.str <- paste0(cv.str, sprintf("```{r %s, %s}\n```\n",
            cv[i], opt.str))
    }
    cv.str <- paste0(cv.str,
        paste("```{r echo=FALSE, results='asis', include=TRUE}",
        "if (mrmd.buf != '') {",
        "cat(mrmd.buf, file=mrmd.tmp)",
        "cat(knit_child(mrmd.tmp, quiet=TRUE), sep='')",
        "mrmd.buf <- ''",
        "dummy <- file.remove(mrmd.tmp)}", "```\n", sep="\n"))
    cat(cv.str, file=mrmd.final)
    mrmd.template <<- tpl
}

append.mrmd <- function(x) {  # mrmd.buf ɕǉ
    mrmd.buf <<- paste0(mrmd.buf, x)
}

    ## opt@C񂻂̑̐ݒ
mrmd.tmp <- "$$MrmdTmp.rmd"  # ꎞIɐ݂rmdt@C̖O
if (file.exists(mrmd.tmp))  file.remove(mrmd.tmp)
mrmd.error <- "Error.txt"  # G[o͗pt@C̖O
if (file.exists(mrmd.error))  file.remove(mrmd.error)
mrmd.final <- "$$final.rmd"  # Schunkŝ߂rmdt@C̖O
mrmd.buf <- ""  # rmdɒ~
mrmd.template <- NULL  # echunkrmdev[gɋL^
    ##  eval() ̈ݒ(֗Ȋp)
set.template <- parse(text=paste0("template <- ",
    "mrmd.template[[opts_current$get('label')]]"))
call.flush <- parse(text=paste("if (mrmd.buf != '') {",
    "cat(mrmd.buf, file=mrmd.tmp)",
    "cat(knit_child(mrmd.tmp, quiet=TRUE), sep='')",
    "mrmd.buf <- ''",
    "dummy <- file.remove(mrmd.tmp)}\n", sep="\n"))
call.child <- parse(text="cat(knit_child(child.file, quiet=TRUE), sep='')")
call.clear <- parse(text=paste(
    "if (file.exists(mrmd.tmp))  file.remove(mrmd.tmp)",
    "if (file.exists(mrmd.final))  file.remove(mrmd.final)",
    "mrmd.buf <- ''",
    "mrmd.template <- NULL", sep="\n"))
